<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="group__group__ble__clk" kind="group">
    <compoundname>group_ble_clk</compoundname>
    <title>BLE ECO      (BLE ECO Clock)</title>
    <innergroup refid="group__group__ble__clk__functions">Functions</innergroup>
    <innergroup refid="group__group__ble__clk__data__type">Enumerated Types</innergroup>
    <innergroup refid="group__group__ble__clk__macros">Macros</innergroup>
    <briefdescription>
<para>This driver provides an API to manage the BLE ECO clock block. </para>    </briefdescription>
    <detaileddescription>
<para>The functions and other declarations used in this driver are in cy_ble_clk.h. You can include cy_pdl.h to get access to all functions and declarations in the PDL.</para><para>The BLE ECO clock is a high-accuracy high-frequency clock that feeds the link-layer controller and the radio Phy.</para><para>This clock is also an input to the system resources subsystem as an alternative high-frequency clock source (ALTHF).</para>
<para><heading level="1">Configuration Considerations</heading></para>
<para>To configure the BLE ECO clock, call <ref kindref="member" refid="group__group__ble__clk__functions_1gae92f61cd532c63d9547c52ccd6757ff7">Cy_BLE_EcoConfigure()</ref>.</para><para>The following code shows how to configure the BLE ECO clock: <programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />BLE<sp />ECO<sp />configuration:<sp />ECO<sp />Frequency:<sp />32<sp />MHZ,<sp />Divider:<sp />2<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Start-up<sp />time(uS):<sp />1500,<sp />Load<sp />cap(pF):<sp />9.9<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />startTime<sp />=<sp />(uint32_t)(1500<sp />/<sp />31.25);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />loadCap<sp /><sp /><sp />=<sp />(uint32_t)((9.9<sp />-<sp />7.5)<sp />/<sp />0.075);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Configure<sp />the<sp />BLE<sp />ECO<sp />clock<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />(void)<sp /><ref kindref="member" refid="group__group__ble__clk__functions_1gae92f61cd532c63d9547c52ccd6757ff7">Cy_BLE_EcoConfigure</ref>(<ref kindref="member" refid="group__group__ble__clk__data__type_1gga90f34ffaefcfb39107f8f60a2a910b10ab18e06510cdcdff510803020cadaed89">CY_BLE_BLESS_ECO_FREQ_32MHZ</ref>,<sp /><ref kindref="member" refid="group__group__ble__clk__data__type_1ggaa50dfcc9b2d385a197421f2262e462ffadc32f9a281d44abf83fab992d183fd9b">CY_BLE_SYS_ECO_CLK_DIV_2</ref>,<sp />loadCap,<sp />startTime,<sp /><ref kindref="member" refid="group__group__ble__clk__data__type_1gga0b65a546765caf85918c9f06e66d25fbabf04e7c9f17091dcbaecd4c80978d021">CY_BLE_ECO_VOLTAGE_REG_AUTO</ref>);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />In<sp />case<sp />if<sp />there<sp />is<sp />a<sp />need<sp />to<sp />get<sp />the<sp />BLE<sp />ECO<sp />frequency<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />bleEcoFreq<sp />=<sp /><ref kindref="member" refid="group__group__sysclk__alt__hf__funcs_1gadc2dc91fa1f0686395f5a5e6059a1c27">Cy_SysClk_AltHfGetFrequency</ref>();</highlight></codeline>
</programlisting> </para>

<para><heading level="1">More Information</heading></para>
<para>See the BLE chapter of the device technical reference manual (TRM).</para>

<para><heading level="1">MISRA-C Compliance</heading></para>
<para>The BLE ECO clock driver has the following specific deviations: <verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;MISRA rule &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Rule Class (Required/ Advisory) &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Rule Description &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Description of Deviation(s)  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;10.1 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;R &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The value of an expression of integer type shall not be implicitly converted to a different underlying type under some circumstances. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;An operand of essentially enum type is being converted to unsigned type as a result of an arithmetic or conditional operation. The conversion does not have any unintended effect.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;This driver does not contains any driver-specific MISRA violations.</verbatim></para>

<para><heading level="1">Changelog</heading></para>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;Version&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Changes&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Reason of Change &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;3.40.1 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Minor documentation updates. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Documentation enhancement.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;3.40 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A new API function &lt;a href="group__group__ble__clk__functions.html#group__group__ble__clk__functions_1gacb085ed4fdaa3bcf7b0582d72c9e7d2c"&gt;Cy_BLE_EcoIsEnabled()&lt;/a&gt; is added. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;API enhancement.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;3.30 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Updated the &lt;a href="group__group__ble__clk__functions.html#group__group__ble__clk__functions_1gae92f61cd532c63d9547c52ccd6757ff7"&gt;Cy_BLE_EcoConfigure()&lt;/a&gt; to reuse the &lt;a href="group__group__sysclk__clk__peri__funcs.html#group__group__sysclk__clk__peri__funcs_1ga6ba76776507e1f3cadcf693c19710f44"&gt;Cy_SysClk_ClkPeriGetFrequency()&lt;/a&gt;. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;API enhancement.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;3.20 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Updated the &lt;a href="group__group__ble__clk__functions.html#group__group__ble__clk__functions_1gae92f61cd532c63d9547c52ccd6757ff7"&gt;Cy_BLE_EcoConfigure()&lt;/a&gt;: it stores the ECO frequency for possible frequency calculation by the &lt;a href="group__group__sysclk__clk__hf__funcs.html#group__group__sysclk__clk__hf__funcs_1gafa8c21271b8cb1b1fd9f7fb489a8d2b3"&gt;Cy_SysClk_ClkHfGetFrequency()&lt;/a&gt;. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;API enhancement.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;3.10 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Updated the &lt;a href="group__group__ble__clk__functions.html#group__group__ble__clk__functions_1gae92f61cd532c63d9547c52ccd6757ff7"&gt;Cy_BLE_EcoConfigure()&lt;/a&gt; use case, when the voltageReg parameter is CY_BLE_ECO_VOLTAGE_REG_BLESSLDO and the Buck core regulator is enabled. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Defect fixing: Before, when the &lt;a href="group__group__ble__clk__functions.html#group__group__ble__clk__functions_1gae92f61cd532c63d9547c52ccd6757ff7"&gt;Cy_BLE_EcoConfigure()&lt;/a&gt; function included the BLE LDO regulator option, the function returned CY_BLE_ECO_HARDWARE_ERROR if the Buck core regulator had been enabled.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;3.0 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The initial version. &lt;br /&gt; The functionality of the BLE ECO clock is migrated from the BLE Middleware to the separated driver (ble_clk). &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Independent usage of BLE ECO clock without BLE Middleware.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>
    </detaileddescription>
  </compounddef>
</doxygen>